﻿// ImageViewerTestExDlg.cpp : 实现文件
//

#include "stdafx.h"
#include "ImageViewerTestEx.h"
#include "ImageViewerTestExDlg.h"
#include "ImageViewerWrapper.h"

#include <fstream>


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// 用于应用程序“关于”菜单项的 CAboutDlg 对话框

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// 对话框数据
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 支持

// 实现
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CImageViewerTestExDlg 对话框




CImageViewerTestExDlg::CImageViewerTestExDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CImageViewerTestExDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CImageViewerTestExDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CImageViewerTestExDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CImageViewerTestExDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON_INIT, &CImageViewerTestExDlg::OnBnClickedButtonInit)
	ON_BN_CLICKED(IDC_BUTTON_PROCESS, &CImageViewerTestExDlg::OnBnClickedButtonProcess)
	ON_BN_CLICKED(IDC_BUTTON_CMDLINE, &CImageViewerTestExDlg::OnBnClickedButtonCmdline)
END_MESSAGE_MAP()


// CImageViewerTestExDlg 消息处理程序

BOOL CImageViewerTestExDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// 将“关于...”菜单项添加到系统菜单中。

	// IDM_ABOUTBOX 必须在系统命令范围内。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 设置此对话框的图标。当应用程序主窗口不是对话框时，框架将自动
	//  执行此操作
	SetIcon(m_hIcon, TRUE);			// 设置大图标
	SetIcon(m_hIcon, FALSE);		// 设置小图标
	
	return TRUE;  // 除非将焦点设置到控件，否则返回 TRUE
}

void CImageViewerTestExDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// 如果向对话框添加最小化按钮，则需要下面的代码
//  来绘制该图标。对于使用文档/视图模型的 MFC 应用程序，
//  这将由框架自动完成。

void CImageViewerTestExDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 用于绘制的设备上下文

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 使图标在工作矩形中居中
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 绘制图标
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//当用户拖动最小化窗口时系统调用此函数取得光标显示。
//
HCURSOR CImageViewerTestExDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

#define PATHS_SPLIT_CHAR _T("\"")

void CImageViewerTestExDlg::OnBnClickedOk()
{
	wstring wcsAppPath = GetCurrentPath();

	vector<wstring> vecPaths;
	generatePicPaths(vecPaths);

	wstring wcsPaths;//
	for (int i=0; i<vecPaths.size();i++)
	{
		wcsPaths += vecPaths[i] + PATHS_SPLIT_CHAR;
	}

	trim(wcsPaths, PATHS_SPLIT_CHAR);
	//= _T("E:\\NiuNiuCapture\\ImageViewer\\bin\\test\\goal.bmp*E:\\NiuNiuCapture\\ImageViewer\\bin\\test\\testjpg.jpg*E:\\NiuNiuCapture\\ImageViewer\\bin\\test\\icon.png*E:\\NiuNiuCapture\\ImageViewer\\bin\\test\\222.png");
	CImageViewerWrapper::Show(wcsPaths.c_str(), 5);
}

void CImageViewerTestExDlg::OnBnClickedButtonInit()
{
	CString strKey;
	GetDlgItemText(IDC_EDIT_AUTHKEY, strKey);
	CImageViewerWrapper::Init((LPCTSTR)strKey, true);
	CImageViewerWrapper::InitParam(eSetSaveName, (UINT_PTR)_T("测试保存名"));
	CImageViewerWrapper::InitParam(eSetTitle, (UINT_PTR)_T("测试窗口名称"));
	CImageViewerWrapper::InitParam(eSetShowMode, 1);

	/*
	m_mapTooltip[_T("origin")] = vecList[0];
	m_mapTooltip[_T("fullscreen")] = vecList[1];
	m_mapTooltip[_T("restore")] = vecList[2];
	m_mapTooltip[_T("rotate")] = vecList[3];
	m_mapTooltip[_T("save")] = vecList[4];
	m_mapTooltip[_T("top")] = vecList[5];
	m_mapTooltip[_T("toprestore")] = vecList[6];
	m_mapTooltip[NEXT_BTN_LAST_TOOLTIP_ID] = vecList[7];
	*/
	CImageViewerWrapper::InitParam(eSetTooltip, (UINT_PTR)_T("fullscreen;restore;mute;unmute;play;pause;narrow;magnify;origin;rotate;save;top;toprestore"));
}


void CImageViewerTestExDlg::OnBnClickedButtonProcess()
{
	wstring wcsAppPath = GetCurrentPath();

	vector<wstring> vecPaths;
	generatePicPaths(vecPaths);

	wstring wcsPaths;
	for (int i=0; i<vecPaths.size();i++)
	{
		wcsPaths += vecPaths[i] + _T("\r\n");
	}
	trim(wcsPaths, _T("\r\n"));

	string strPaths = UnicodeToUtf8OrAnsi(wcsPaths.c_str(), CP_UTF8);

	wstring pathFilePath = wcsAppPath + _T("testpicpaths.dat");
	std::ofstream pathfile;    
	pathfile.open(pathFilePath.c_str(), std::ios::out | std::ios::binary | std::ios::trunc);    

	pathfile << strPaths;    
	pathfile.close();    


	CString strKey;
	GetDlgItemText(IDC_EDIT_AUTHKEY, strKey);

	CString strParams;
	strParams.Format(_T("%d*%s*%s*%d"), 1, strKey, pathFilePath.c_str(), 1);
	
	wstring wcsExePath = wcsAppPath + _T("ViewerWrapper.exe");
	ShellExecute(NULL, _T("open"), wcsExePath.c_str(), strParams, NULL, SW_SHOW);

}


void CImageViewerTestExDlg::OnBnClickedButtonCmdline()
{
	wstring wcsAppPath = GetCurrentPath();

	vector<wstring> vecPaths;
	generatePicPaths(vecPaths);

	wstring wcsPaths;
	for (int i=0; i<vecPaths.size();i++)
	{
		wcsPaths += _T("\"") + vecPaths[i] + _T("\"");
	}

	CString strKey;
	GetDlgItemText(IDC_EDIT_AUTHKEY, strKey);

	CString strParams;
	strParams.Format(_T("%d*%s*%s*%d"), 0, strKey, wcsPaths.c_str(), 1);

	wstring wcsExePath = wcsAppPath + _T("ViewerWrapper.exe");
	ShellExecute(NULL, _T("open"), wcsExePath.c_str(), strParams, NULL, SW_SHOW);

}


void CImageViewerTestExDlg::generatePicPaths(vector<wstring>& vecPaths)
{
	wstring wcsAppPath = GetCurrentPath();
	vecPaths.push_back(wcsAppPath + _T("\\test\\testjpg.jpg"));
	vecPaths.push_back(wcsAppPath + _T("\\test\\giftest.gif"));
	vecPaths.push_back(wcsAppPath + _T("\\test\\goal.bmp"));
	vecPaths.push_back(wcsAppPath + _T("\\test\\icon.png"));
	vecPaths.push_back(wcsAppPath + _T("\\test\\라이선스  111.png"));
	vecPaths.push_back(wcsAppPath + _T("\\test\\testvideo.mp4"));
}