#pragma once
#include <string>
using namespace std;


enum eViewerParam : int
{
	eSetShowMode = 1,	//ǷͼƬӦǰĴڴС
	eSetTooltip = 2,	//ðťtooltipϢ
	eSetSaveName = 3,		//ñϵĬϢ
	eSetTitle = 4,			//ôڱ⣨ʾʱҪ
	eCanDragAndPaste = 5,	//Ƿճ϶ͼƬ
};

typedef int (__stdcall *FnShowViewer)(const wchar_t* imagePaths, int currPos);
typedef int (__stdcall *FnInitViewer)(const wchar_t* authInfo, int showInTaskbar);
typedef int (__stdcall *FnInitParam)(int flag, UINT_PTR flagvalue);

string UnicodeToUtf8OrAnsi(const WCHAR * lpszStr, UINT codePage);
wstring GetCurrentPath();
wstring& trim(wstring& text, const wchar_t* Regex = NULL);

class CImageViewerWrapper
{
public:
	CImageViewerWrapper(void);
	~CImageViewerWrapper(void);

	static int Init(const wchar_t* authInfo, int showInTaskbar);
	static int InitParam(int flag, UINT_PTR flagvalue);
	static int Show(const wchar_t* imagePaths, int currPos);

private:
	static HMODULE s_hModule;
	static FnShowViewer s_ShowViewer;
	static FnInitViewer s_InitViewer;
	static FnInitParam  s_InitParam;
};
